/* flags 
 valaccodenewline.vala
 *
 * Copyright (C) 2006  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <valaccodenewline.h>

struct _ValaCCodeNewlinePrivate {
};
#define VALA_CCODE_NEWLINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_CCODE_NEWLINE, ValaCCodeNewlinePrivate))
enum  {
	VALA_CCODE_NEWLINE_DUMMY_PROPERTY,
};
static void vala_ccode_newline_real_write (ValaCCodeNode* base, ValaCCodeWriter* writer);
static void vala_ccode_newline_dispose (GObject * obj);

static void vala_ccode_newline_real_write (ValaCCodeNode* base, ValaCCodeWriter* writer)
{
	ValaCCodeNewline * self = VALA_CCODE_NEWLINE (base);
	g_return_if_fail (VALA_IS_CCODE_WRITER (writer));
	vala_ccode_writer_write_newline (writer);
}


void vala_ccode_newline_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec)
{
	ValaCCodeNewline * self = VALA_CCODE_NEWLINE (object);
	switch (property_id) {
	}
}


void vala_ccode_newline_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec)
{
	ValaCCodeNewline * self = VALA_CCODE_NEWLINE (object);
	switch (property_id) {
	}
}


static void vala_ccode_newline_class_init (ValaCCodeNewlineClass * klass)
{
	G_OBJECT_CLASS (klass)->get_property = vala_ccode_newline_get_property;
	G_OBJECT_CLASS (klass)->set_property = vala_ccode_newline_set_property;
	VALA_CCODE_NODE_CLASS (klass)->write = vala_ccode_newline_real_write;
}


static void vala_ccode_newline_init (ValaCCodeNewline * self)
{
}


static void vala_ccode_newline_dispose (GObject * obj)
{
	ValaCCodeNewline * self = VALA_CCODE_NEWLINE (obj);
	ValaCCodeNewlineClass * klass;
	GObjectClass * parent_class;
	klass = VALA_CCODE_NEWLINE_CLASS (g_type_class_peek (VALA_TYPE_CCODE_NEWLINE));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	parent_class->dispose (obj);
}


GType vala_ccode_newline_get_type ()
{
	static GType g_define_type_id = 0;
	if (G_UNLIKELY (g_define_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeNewlineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_newline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeNewline), 0, (GInstanceInitFunc) vala_ccode_newline_init };
		g_define_type_id = g_type_register_static (VALA_TYPE_CCODE_NODE, "ValaCCodeNewline", &g_define_type_info, 0);
	}
	return g_define_type_id;
}



