/* valaccodenode.vala
 *
 * Copyright (C) 2006  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <valaccodenode.h>

struct _ValaCCodeNodePrivate {
};
#define VALA_CCODE_NODE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_CCODE_NODE, ValaCCodeNodePrivate))
enum  {
	VALA_CCODE_NODE_DUMMY_PROPERTY,
};
static void vala_ccode_node_dispose (GObject * obj);

void vala_ccode_node_write (ValaCCodeNode* self, ValaCCodeWriter* writer)
{
	VALA_CCODE_NODE_GET_CLASS (self)->write (self, writer);
}


void vala_ccode_node_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec)
{
	ValaCCodeNode * self = VALA_CCODE_NODE (object);
	switch (property_id) {
	}
}


void vala_ccode_node_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec)
{
	ValaCCodeNode * self = VALA_CCODE_NODE (object);
	switch (property_id) {
	}
}


static void vala_ccode_node_class_init (ValaCCodeNodeClass * klass)
{
	G_OBJECT_CLASS (klass)->get_property = vala_ccode_node_get_property;
	G_OBJECT_CLASS (klass)->set_property = vala_ccode_node_set_property;
}


static void vala_ccode_node_init (ValaCCodeNode * self)
{
}


static void vala_ccode_node_dispose (GObject * obj)
{
	ValaCCodeNode * self = VALA_CCODE_NODE (obj);
	ValaCCodeNodeClass * klass;
	GObjectClass * parent_class;
	klass = VALA_CCODE_NODE_CLASS (g_type_class_peek (VALA_TYPE_CCODE_NODE));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	parent_class->dispose (obj);
}


GType vala_ccode_node_get_type ()
{
	static GType g_define_type_id = 0;
	if (G_UNLIKELY (g_define_type_id == 0)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeNode), 0, (GInstanceInitFunc) vala_ccode_node_init };
		g_define_type_id = g_type_register_static (G_TYPE_OBJECT, "ValaCCodeNode", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return g_define_type_id;
}



