/* valacodegenerator.vala
 *
 * Copyright (C) 2006  Jürg Billeter, Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <rasa@gmx.ch>
 */

#ifndef __VALACODEGENERATOR_H__
#define __VALACODEGENERATOR_H__

#include <glib.h>
#include <string.h>
#include <valaccodestatement.h>
#include <valaccodeexpression.h>
#include <valaccodefragment.h>
#include <valaccodecommaexpression.h>
#include <valacodevisitor.h>
#include <valacodecontext.h>
#include <valasourcefile.h>
#include <valaclass.h>
#include <valainterface.h>
#include <valastruct.h>
#include <valaenum.h>
#include <valaenumvalue.h>
#include <valacallback.h>
#include <valaconstant.h>
#include <valafield.h>
#include <valamethod.h>
#include <valadatatype.h>
#include <valaproperty.h>
#include <valacodenode.h>
#include <valaformalparameter.h>
#include <valapropertyaccessor.h>
#include <valaconstructor.h>
#include <valablock.h>
#include <valaemptystatement.h>
#include <valadeclarationstatement.h>
#include <valavariabledeclarator.h>
#include <valainitializerlist.h>
#include <valatypereference.h>
#include <valaexpression.h>
#include <valaexpressionstatement.h>
#include <valastatement.h>
#include <valaifstatement.h>
#include <valawhilestatement.h>
#include <valaforstatement.h>
#include <valaforeachstatement.h>
#include <valabreakstatement.h>
#include <valacontinuestatement.h>
#include <valasymbol.h>
#include <valareturnstatement.h>
#include <valabooleanliteral.h>
#include <valacharacterliteral.h>
#include <valaintegerliteral.h>
#include <valarealliteral.h>
#include <valastringliteral.h>
#include <valanullliteral.h>
#include <valaliteralexpression.h>
#include <valamemberaccess.h>
#include <valaparenthesizedexpression.h>
#include <valainvocationexpression.h>
#include <valaelementaccess.h>
#include <valapostfixexpression.h>
#include <valaobjectcreationexpression.h>
#include <valatypeofexpression.h>
#include <valaunaryexpression.h>
#include <valacastexpression.h>
#include <valabinaryexpression.h>
#include <valatypecheck.h>
#include <valaconditionalexpression.h>
#include <valalambdaexpression.h>
#include <valaassignment.h>

G_BEGIN_DECLS


#define VALA_TYPE_CODE_GENERATOR (vala_code_generator_get_type ())
#define VALA_CODE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_CODE_GENERATOR, ValaCodeGenerator))
#define VALA_CODE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_CODE_GENERATOR, ValaCodeGeneratorClass))
#define VALA_IS_CODE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_CODE_GENERATOR))
#define VALA_IS_CODE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_CODE_GENERATOR))
#define VALA_CODE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_CODE_GENERATOR, ValaCodeGeneratorClass))

typedef struct _ValaCodeGenerator ValaCodeGenerator;
typedef struct _ValaCodeGeneratorClass ValaCodeGeneratorClass;
typedef struct _ValaCodeGeneratorPrivate ValaCodeGeneratorPrivate;

/**
 * Code visitor generating C Code.
 */
struct _ValaCodeGenerator {
	ValaCodeVisitor parent;
	ValaCodeGeneratorPrivate * priv;
};
struct _ValaCodeGeneratorClass {
	ValaCodeVisitorClass parent;
};

void vala_code_generator_emit (ValaCodeGenerator* self, ValaCodeContext* context);
gboolean vala_code_generator_get_memory_management (ValaCodeGenerator* self);
void vala_code_generator_set_memory_management (ValaCodeGenerator* self, gboolean value);
GType vala_code_generator_get_type ();

G_END_DECLS

#endif
