/* valasymbol.vala
 *
 * Copyright (C) 2006  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#ifndef __VALASYMBOL_H__
#define __VALASYMBOL_H__

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <valacodenode.h>

G_BEGIN_DECLS


#define VALA_TYPE_SYMBOL (vala_symbol_get_type ())
#define VALA_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_SYMBOL, ValaSymbol))
#define VALA_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_SYMBOL, ValaSymbolClass))
#define VALA_IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_SYMBOL))
#define VALA_IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_SYMBOL))
#define VALA_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_SYMBOL, ValaSymbolClass))

typedef struct _ValaSymbolPrivate ValaSymbolPrivate;

struct _ValaSymbol {
	GObject parent;
	ValaSymbolPrivate * priv;
	ValaSymbol* parent_symbol;
	char* name;
	gboolean active;
};
struct _ValaSymbolClass {
	GObjectClass parent;
};

char* vala_symbol_get_full_name (ValaSymbol* self);
void vala_symbol_add (ValaSymbol* self, char* s, ValaSymbol* sym);
ValaSymbol* vala_symbol_lookup (ValaSymbol* self, char* s);
ValaCodeNode* vala_symbol_get_node (ValaSymbol* self);
void vala_symbol_set_node (ValaSymbol* self, ValaCodeNode* value);
GType vala_symbol_get_type ();

G_END_DECLS

#endif
